/*  
1) Mirror image transaction costs at home and abroad 
2) bh_t = m_t*mon_mult
3) General Transaction Costs Function 
4) No am in psi(.) 
*/

var pi_h,pi_f,pi,pi_star,s,lambda,lambda_hat, psi_hat, psi3_hat,psi4_hat,
    mc,mc_star,tot,q,ph_hat,pf_hat,i,i_star, idiff,yh,yf,
    c,m,bh,bf,c_star,m_star,bf_star,bh_star,bh_gy,bf_gy,
    bh_m,bf_m,bh_g,bf_g,tau,tau_star,yh_bar,yf_bar,yh_tilde,yf_tilde, bhgy_diff, bh_p,
    a,a_star,v,v_star,u,u_star,vtau,vtau_star,g,g_star, psi_star_hat, chi, chi_star,
    psi1_hat, psi2_hat, psi1_star_hat, psi2_star_hat, psi3_star_hat, psi4_star_hat, h, h_tilde, h_star, h_star_tilde, km_t, kbh_t, kbf_t, km_star_t, kbh_star_t, kbf_star_t, b_qe, bf_gdp,
    d,n,w,itilde, itilde_star, itilde_diff, rdiff, delta_y, delta_c, delta_ystar, delta_cstar, delta_bhg, r, r_star, delta_bhgy, delta_m,delta_q,delta_s;

varexo eps_a,eps_astar,eps_v,eps_vstar,eps_vtau,eps_vtaustar;

parameters  theta,beta, sigma,phi,rho_i,phi_pi,phi_y,k_tau1,k_tauy,gamma, eta, psi_bar, psi_star_bar,
            phi_pi_star, phi_y_star,k_tau1_star,k_tauy_star, lambda_h,lambda_f, ah,af, kq_tot,ktot, chi_tr, gy
            alpha_g,alpha_d,alpha1,alpha2,alpha3,alpha4,psi,Abar,mon_mult, bh_m_ss,bf_m_ss, Q_ss,php_ss,pfp_ss,pfp_star_ss,tot_ss,
            rho_a,rho_astar,rho_aastar,rho_v,rho_vstar,rho_vvstar,rho_u,rho_ustar,rho_uustar,rho_vtau,rho_vtaustar,rho_vvtaustar,rho_g,rho_gstar,sigma_g,sigma_gstar,sigma_ggstar,
            sigma_a,sigma_astar,sigma_aastar,sigma_v,sigma_vstar,sigma_vvstar,sigma_u,sigma_ustar,sigma_uustar,sigma_vtau,sigma_vtaustar,sigma_vvtaustar,sigma_chi,sigma_chistar,sigma_chichistar,rho_chi,rho_chistar,
            psi1,psi2,psi3,psi4,psi1_star,psi2_star,psi3_star,psi4_star,tau_ss,tau_star_ss,c_ss,y_ss,g_ss,g_star_ss,c_star_ss,bh_bar,bf_bar,i_ss,i_star_ss,m_ss,m_star_ss, k_cpsi, k_cpsistar, k_cstarpsi, k_cstarpsistar,
            bh_ss,bf_ss,bf_star_ss,bh_star_ss,rho_tau, rho_tau_star, k_taug,k_taug_star, phi_b, am,ab,eta_b,eta_m, kbh,kbf,km, h_ss, h_star_ss, h_tilde_ss, h_star_tilde_ss, k_totpsi, k_totpsistar, k6,k7, k6_star, k7_star, 
            k_tot1,k_tot_yh,k_tot_yf,k_tot_c,k_tot_cstar,k_cyh,k_cyf,k_cc,k1,k2,k3,k_cyh_star,k_cyf_star,k_cc_star,k1_star,k2_star,k3_star,k_tot_g,k_tot_gstar,k_cg,k_cgstar,k_cg_star,k_cgstar_star,k4,k5,k4_star,k5_star,
            rho_kbh,sigma_kbh,rho_qe,sigma_qe, w_ss, n_ss, d_ss; 

theta = 0.667; //  Burnside et al (2011) = 0.75, 0.667
sigma = 3; // 2, 3 Typically chosen to be between 1 and 5 
gamma = 0.5;
phi = 1.5001;   // Inverse Frisch Elasticity
lambda_h = 7.66; // elasticity of substitution home and foreign goods
lambda_f = lambda_h; 
eta = 1.5001;   //Karabarbounis(2014) = 1.5  CKM(2002) - between 1 and 2 
ah = 0.8;  //  home bias in consumption
af = 1 - ah; 
chi_tr = 0;
phi_c =0; 

rho_i = 0.9;  
rho_tau = 0.92; 
phi_pi = 1.5 ; 
phi_y = 0; 
k_tau1 =  0.48; 
k_tauy = 0; 
k_taug = 0; 
gy = -0;  

phi_pi_star = phi_pi; 
phi_y_star =  phi_y; 
phi_b = -0; 
rho_tau_star = rho_tau; 
k_tau1_star = k_tau1; 
k_tauy_star = k_tauy; 
k_taug_star = k_taug; 

beta = 0.9901; 
alpha_g = 0.22; 
alpha_d = 0.5; 
alpha1 = 18;
am = 1;
ab = 0.999848; 
km = 1; 
kbh = 0.425; 
kbf = kbh; 
eta_m = 0.1; 
eta_b = 0.25001; 
psi = 4.2e-18;  
Abar = 1; 
mon_mult = 1;


rho_a =  0.97;  //BerrielBhattarai (2014) = 0.98, Fernald TFP = 0.97 , Cheri et al (2002) = 0.95
rho_aastar = 0; 
sigma_a = 1*0.0078; // BerrielBhattarai (2014) - 0.006, Fernald TFP - 0.0078 (or 0.007) , Chari et al (2002) = 0.007
sigma_astar = 1*sigma_a; 
sigma_aastar = sqrt(0)*sigma_a; // Chari et al(2002) = 0.25

rho_v =  0;  // 0.5 (Quarterly) There is this one paper that estimates this much rho?
rho_vvstar = 0; 
sigma_v = 1*0.0033;  //  BerrielBhattarai (2014) - 0.0091 , DavigLeeper(2006) = 0.0036 
sigma_vstar = 1*sigma_v; 
sigma_vvstar = sqrt(0)*sigma_v*sigma_vstar; 

rho_vtau =  0;  
rho_vvtaustar = 0; 
sigma_vtau = 1*0.0057; 
sigma_vtaustar = 1*sigma_vtau; 
sigma_vvtaustar = sqrt(0)*sigma_vtau*sigma_vtaustar; 

rho_astar = rho_a; 
rho_vstar = rho_v; 
rho_vtaustar = rho_vtau; 

c0 = (1-alpha_g)^(phi/(phi+sigma))*(Abar)^((phi+1)/(phi+sigma))*((lambda_h-1)/lambda_h)^(1/(phi+sigma));
y0 = c0/((1-alpha_g));
n0 = y0/Abar;  
tot0 = 1;

php0 = (ah + af*tot0^(1-eta))^(-1/(1-eta));  
pfp0 = (ah*tot0^(eta-1)+af)^(-1/(1-eta));
Q0 = ((ah*tot0^(1-eta)+af)/(ah+af*tot0^(1-eta)))^(1/(1-eta)); 
pfp_star0 = pfp0/Q0; 

bh_bar = alpha_d*php0*y0; 
bf_bar = alpha_d*pfp_star0*y0; 

alpha2 = (1-alpha1); 
alpha3 = (1-alpha1)*ab; 
alpha4 = (1-alpha1)*(1-ab); 

bh0 = 0.7*bh_bar; 
bf0 = 0.1*bh0; 
bh_star0 = bf0; 
bf_star0 = bh0; 
i0 = 1/beta-1;
i_star0 = 1/beta -1; 

m0 = 0.35*(1/km)*((beta-1)/(alpha2*psi*c0^(alpha1)*bh0^alpha3*bf0^alpha4))^(1/(alpha2-1));
m_star0 = 0.35*(1/km)*((beta-1)/(alpha2*psi*c0^(alpha1)*bf_star0^alpha3*bh_star0^alpha4))^(1/(alpha2-1));

options = optimset;
options.Display = 'on';
options.MaxFunEvals = 1e5;
options.MaxIter = 1e4;
options.TolFun = 1e-6;

x0 = [bh0,bf0,bh_star0,bf_star0,i0,i_star0,c0,tot0,m0,m_star0,y0]; 
x0 = [log(bh0),log(bf0),log(bh_star0),log(bf_star0),i0,i_star0,c0,tot0,m0,m_star0,y0]; 

[x_ss,fval, exitflag] = evalin('base', 'fsolve(@(x)  sstate_fp5(x,beta,alpha1,am,ab,km,kbh,kbf,gamma,psi,mon_mult,Abar,phi,lambda_h,sigma,ah,af,eta,alpha_g,alpha_d,eta_b,eta_m,phi_c),x0,options)');

bh_ss= exp(x_ss(1)); 
bf_ss = exp(x_ss(2)); 
bh_star_ss = exp(x_ss(3)); 
bf_star_ss = exp(x_ss(4));
i_ss = x_ss(5); 
i_star_ss = x_ss(6); 
c_ss = x_ss(7); 
tot_ss = x_ss(8); 
m_ss = x_ss(9); 
m_star_ss = x_ss(10); 
y_ss = x_ss(11); 

bh_m_ss = m_ss/mon_mult; 
bf_m_ss = m_star_ss/mon_mult; 

php_ss = (ah + af*tot_ss^(1-eta))^(-1/(1-eta));  
pfp_ss = (ah*tot_ss^(eta-1)+af)^(-1/(1-eta));
Q_ss = ((ah*tot_ss^(1-eta)+af)/(ah+af*tot_ss^(1-eta)))^(1/(1-eta)); 
pfp_star_ss = pfp_ss/Q_ss; 

g_ss = alpha_g*php_ss*y_ss; 
g_star_ss = alpha_g*pfp_star_ss*y_ss; 
c_star_ss = c_ss; 

y_star_ss = y_ss; 

bh_bar = alpha_d*php_ss*y_ss; 
bf_bar = alpha_d*pfp_star_ss*y_star_ss; 

n_ss = y_ss/Abar; 
w_ss = ((lambda_h-1)/lambda_h)*php_ss; 
d_ss = (y_ss/lambda_h)*php_ss; 
mc_ss = (lambda_h-1)/lambda_h; 

tau_ss = i_ss*bh_bar+g_ss - i_ss*m_ss/mon_mult; 
tau_star_ss = i_star_ss*bf_bar + g_star_ss - i_star_ss*m_star_ss/mon_mult; 

h_tilde_ss = (ab*(kbh*bh_ss)^((eta_b-1)/eta_b) + (1-ab)*(kbf*bf_ss)^((eta_b-1)/eta_b))^(eta_b/(eta_b-1));
h_ss = ((km*m_ss)^((eta_m-1)/eta_m) + h_tilde_ss^((eta_m-1)/eta_m))^(eta_m/(eta_m-1)); 
psi_bar = psi*c_ss^(alpha1)*h_ss^(1-alpha1);

h_star_tilde_ss = (ab*(kbh*bf_star_ss)^((eta_b-1)/eta_b) + (1-ab)*(kbf*bh_star_ss)^((eta_b-1)/eta_b))^(eta_b/(eta_b-1));
h_star_ss = ((km*m_star_ss)^((eta_m-1)/eta_m) + h_star_tilde_ss^((eta_m-1)/eta_m))^(eta_m/(eta_m-1)); 
psi_star_bar = psi*c_star_ss^(alpha1)*h_star_ss^(1-alpha1);

psi1 = alpha1*psi_bar/c_ss; 
psi2 = (1-alpha1)*(psi_bar/h_ss^((eta_m-1)/eta_m))*m_ss^(-1/eta_m)*km^((eta_m-1)/eta_m);
psi3 = (1-alpha1)*ab*(psi_bar/h_ss^((eta_m-1)/eta_m))*bh_ss^(-1/eta_b)*h_tilde_ss^(1/eta_b - 1/eta_m)*kbh^((eta_b-1)/eta_b);
psi4 = (1-alpha1)*(1-ab)*(psi_bar/h_ss^((eta_m-1)/eta_m))*bf_ss^(-1/eta_b)*h_tilde_ss^(1/eta_b - 1/eta_m)*kbf^((eta_b-1)/eta_b);

psi1_star = alpha1*psi_star_bar/c_star_ss; 
psi2_star = (1-alpha1)*(psi_star_bar/h_star_ss^((eta_m-1)/eta_m))*m_star_ss^(-1/eta_m)*km^((eta_m-1)/eta_m);
psi3_star = (1-alpha1)*ab*(psi_star_bar/h_star_ss^((eta_m-1)/eta_m))*bf_star_ss^(-1/eta_b)*h_star_tilde_ss^(1/eta_b - 1/eta_m)*kbh^((eta_b-1)/eta_b);
psi4_star = (1-alpha1)*(1-ab)*(psi_star_bar/h_star_ss^((eta_m-1)/eta_m))*bh_star_ss^(-1/eta_b)*h_star_tilde_ss^(1/eta_b - 1/eta_m)*kbf^((eta_b-1)/eta_b);

kq_tot = Q_ss^(eta-1)*(ah*tot_ss^(1-eta)/(ah+af*tot_ss^(1-eta)) - Q_ss*af*tot_ss^(1-eta)/(ah + af*tot_ss^(1-eta))); 
ktot = 1/(1-(Q_ss^eta*ah*(c_ss+g_ss)/(y_ss*pfp_ss^eta)-(Q_ss^eta*(c_ss+g_ss)*af*gamma/(1-gamma))/(y_ss*php_ss^eta))*kq_tot + (1/eta)*(psi_star_bar*Q_ss/(y_ss*pfp_ss))-(1/eta)*(psi_star_bar/y_ss)*(Q_ss/pfp_ss)*(eta-1)*ah*tot_ss^(eta-1)/(ah*tot_ss^(eta-1)+af) - (1/eta)*(psi_bar/(y_ss*php_ss))*(eta-1)*(af*tot_ss^(1-eta)/(ah+af*tot_ss^(1-eta))));

k_tot1 = -(y_ss*php_ss^eta*eta*af*tot_ss^(1-eta)/(ah + af*tot_ss^(1-eta)) + (gamma/(1-gamma))*Q_ss^eta*(c_star_ss+g_star_ss)*af*eta*kq_tot + psi_bar*af*tot_ss^(1-eta)*(1-eta)); 

k_tot_yh = ktot*(1/eta); 
k_tot_yf =  ktot*(-1/eta); 
k_tot_c =  ktot*(1/eta)*(((1-gamma)/gamma)*af*c_ss/(y_ss*pfp_ss^eta)-c_ss*ah/(y_ss*php_ss^eta)); 
k_tot_cstar =  ktot*(1/eta)*(Q_ss^eta*ah*c_ss/(y_ss*pfp_ss^eta)-(Q_ss^eta*c_ss*af*gamma/(1-gamma))/(y_ss*php_ss^eta)); 
k_tot_g =  ktot*(1/eta)*(((1-gamma)/gamma)*af*g_ss/(y_ss*pfp_ss^eta)-g_ss*ah/(y_ss*php_ss^eta));
k_tot_gstar = ktot*(1/eta)*(Q_ss^eta*ah*g_star_ss/(y_ss*pfp_ss^eta)-(Q_ss^eta*g_star_ss*af*gamma/(1-gamma))/(y_ss*php_ss^eta)); 
k_totpsi= ktot*(1/eta)*(psi_bar/(y_ss*php_ss));
k_totpsistar= ktot*(1/eta)*(psi_star_bar*Q_ss/(y_ss*pfp_ss)); 

k_cyh = (1/(ah*c_ss - k_tot1*k_tot_c))*(y_ss*php_ss^eta+k_tot1*k_tot_yh); 
k_cyf = (1/(ah*c_ss - k_tot1*k_tot_c))*(k_tot1*k_tot_yf); 
k_cc = (1/(ah*c_ss - k_tot1*k_tot_c))*(k_tot1*k_tot_cstar-gamma/(1-gamma)*Q_ss^eta*c_ss*af); 
k_cg = (1/(ah*c_ss - k_tot1*k_tot_c))*(k_tot1*k_tot_g-ah*g_ss);
k_cgstar = (1/(ah*c_ss - k_tot1*k_tot_c))*(k_tot1*k_tot_gstar-(gamma/(1-gamma))*Q_ss^eta*g_star_ss*af);
k_cpsi = (1/(ah*c_ss - k_tot1*k_tot_c))*(k_tot1*k_totpsi - psi_bar*(ah+af*tot_ss^(1-eta)));
k_cpsistar = (1/(ah*c_ss - k_tot1*k_tot_c))*(k_tot1*k_totpsistar); 

k1 = phi + (af*tot_ss^(1-eta)/(ah+af*tot_ss^(1-eta)))*k_tot_yh + (sigma + (af*tot_ss^(1-eta)/(ah + af*tot_ss^(1-eta)))*k_tot_c)*k_cyh; 
k2 = (af*tot_ss^(1-eta)/(ah + af*tot_ss^(1-eta)))*k_tot_yf + (sigma + (af*tot_ss^(1-eta)/(ah + af*tot_ss^(1-eta)))*k_tot_c)*k_cyf; 
k3 = (af*tot_ss^(1-eta)/(ah + af*tot_ss^(1-eta)))*k_tot_cstar + (sigma + (af*tot_ss^(1-eta)/(ah + af*tot_ss^(1-eta)))*k_tot_c)*k_cc;
k4 = (sigma + af*tot_ss^(1-eta)/(ah + af*tot_ss^(1-eta))*k_tot_c)*k_cg + (af*tot_ss^(1-eta)/(ah+af*tot_ss^(1-eta)))*k_tot_g; 
k5 = (sigma + af*tot_ss^(1-eta)/(ah + af*tot_ss^(1-eta))*k_tot_c)*k_cgstar + (af*tot_ss^(1-eta)/(ah+af*tot_ss^(1-eta)))*k_tot_gstar; 
k6 = (af*tot_ss^(1-eta)/(ah + af*tot_ss^(1-eta)))*k_totpsi + (sigma + (af*tot_ss^(1-eta)/(ah + af*tot_ss^(1-eta)))*k_tot_c)*k_cpsi; 
k7 = (af*tot_ss^(1-eta)/(ah + af*tot_ss^(1-eta)))*k_totpsistar + (sigma + (af*tot_ss^(1-eta)/(ah + af*tot_ss^(1-eta)))*k_tot_c)*k_cpsistar;  

k_cyh_star = (1/(gamma/(1-gamma)*Q_ss^eta*c_ss*af - k_tot1*k_tot_cstar))*(y_ss*php_ss^eta+k_tot1*k_tot_yh); 
k_cyf_star = (1/(gamma/(1-gamma)*Q_ss^eta*c_ss*af - k_tot1*k_tot_cstar))*(k_tot1*k_tot_yf); 
k_cc_star = (1/(gamma/(1-gamma)*Q_ss^eta*c_ss*af - k_tot1*k_tot_cstar))*(k_tot1*k_tot_c-ah*c_ss); 
k_cg_star = (1/(gamma/(1-gamma)*Q_ss^eta*c_ss*af - k_tot1*k_tot_cstar))*(k_tot1*k_tot_g-ah*g_ss);
k_cgstar_star = (1/(gamma/(1-gamma)*Q_ss^eta*c_ss*af - k_tot1*k_tot_cstar))*(k_tot1*k_tot_gstar-(gamma/(1-gamma))*Q_ss^eta*g_star_ss*af);
k_cstarpsi = (1/(gamma/(1-gamma)*Q_ss^eta*c_ss*af - k_tot1*k_tot_cstar))*(k_tot1*k_totpsi - psi_bar*(ah+af*tot_ss^(1-eta)));
k_cstarpsistar = (1/(gamma/(1-gamma)*Q_ss^eta*c_ss*af - k_tot1*k_tot_cstar))*k_tot1*k_totpsistar; 

k1_star = phi - (af*tot_ss^(eta-1)/(ah+af*tot_ss^(eta-1)))*k_tot_yf + (sigma - (af*tot_ss^(eta-1)/(ah + af*tot_ss^(eta-1)))*k_tot_cstar)*k_cyf_star; 
k2_star = -(af*tot_ss^(eta-1)/(ah + af*tot_ss^(eta-1)))*k_tot_yh + (sigma - (af*tot_ss^(eta-1)/(ah + af*tot_ss^(eta-1)))*k_tot_cstar)*k_cyh_star; 
k3_star = -(af*tot_ss^(eta-1)/(ah + af*tot_ss^(eta-1)))*k_tot_c + (sigma - (af*tot_ss^(eta-1)/(ah + af*tot_ss^(eta-1)))*k_tot_cstar)*k_cc_star;
k4_star =  (sigma - (af*tot_ss^(eta-1)/(ah + af*tot_ss^(eta-1)))*k_tot_cstar)*k_cg_star - (af*tot_ss^(eta-1)/(ah+af*tot_ss^(eta-1)))*k_tot_g; 
k5_star =  (sigma - (af*tot_ss^(eta-1)/(ah + af*tot_ss^(eta-1)))*k_tot_cstar)*k_cgstar_star - (af*tot_ss^(eta-1)/(ah+af*tot_ss^(eta-1)))*k_tot_gstar; 
k6_star =  (sigma - (af*tot_ss^(eta-1)/(ah + af*tot_ss^(eta-1)))*k_tot_cstar)*k_cstarpsi - (af*tot_ss^(eta-1)/(ah + af*tot_ss^(eta-1)))*k_totpsi; 
k7_star = (sigma - (af*tot_ss^(eta-1)/(ah + af*tot_ss^(eta-1)))*k_tot_cstar)*k_cstarpsistar - (af*tot_ss^(eta-1)/(ah + af*tot_ss^(eta-1)))*k_totpsistar;

model (linear);
//Inflation Equations
pi_h = ((1-theta)*(1-beta*theta)/theta)*mc + beta*pi_h(+1)+u;
pi_f = ((1-theta)*(1-beta*theta)/theta)*mc_star + beta*pi_f(+1)+u_star; 
pi = pi_h + (af*tot_ss^(1-eta)/(ah + af*tot_ss^(1-eta)))*(tot - tot(-1));
pi_star = pi_f -((ah*tot_ss^(eta-1))/(ah*tot_ss^(eta-1) + af))*(tot-tot(-1)) + q - q(-1); 

tot = k_tot_yh*yh + k_tot_yf*yf + k_tot_c*c + k_tot_cstar*c_star + k_tot_g*g + k_tot_gstar*g_star + (ktot/eta)*(psi_star_bar*Q_ss/(y_ss*pfp_ss))*(psi_star_hat) - (ktot/eta)*(psi_bar/(y_ss*php_ss))*(psi_hat); 

ph_hat = -(af*tot_ss^(1-eta)/(ah + af*tot_ss^(1-eta)))*tot;
pf_hat = (ah*tot_ss^(eta-1)/(ah*tot_ss^(eta-1) + af))*tot;
q = kq_tot*tot; 
pi + q - q(-1) = pi_star + s - s(-1); 

// Optimality Conditions 

0 = sigma*(c(+1)-c) + (psi1_hat(+1) - psi1_hat) + pi(+1) + psi2_hat - (chi(+1) - chi); 
0 = sigma*(c(+1)-c) + (psi1_hat(+1) - psi1_hat) + pi(+1) -i + psi3_hat - (chi(+1) - chi); 
0 = sigma*(c(+1)-c) + (psi1_hat(+1) - psi1_hat) + pi(+1) -i_star -s(+1) + s + psi4_hat - (chi(+1) - chi); 
0 = sigma*(c_star(+1)-c_star) + (psi1_star_hat(+1) - psi1_star_hat) + pi_star(+1) + psi2_star_hat - (chi_star(+1) - chi_star); 
0 = sigma*(c_star(+1)-c_star) + (psi1_star_hat(+1) - psi1_star_hat) + pi_star(+1) -i_star + psi3_star_hat - (chi_star(+1) - chi_star); 
0 = sigma*(c_star(+1)-c_star) + (psi1_star_hat(+1) - psi1_star_hat) + pi_star(+1) -i + s(+1) - s + psi4_star_hat - (chi_star(+1) - chi_star); 

// Liquidity Function 
psi_hat = alpha1*c + (1-alpha1)*h; 
psi1_hat = (psi1/(1+psi1))*(psi_hat - c); 
psi2_hat = (psi2/(1+psi2))*(psi_hat - (1/eta_m)*m + ((eta_m-1)/eta_m)*km_t - ((eta_m-1)/eta_m)*h); 
psi3_hat = (psi3/(1+psi3))*(psi_hat - (1/eta_b)*bh + (1/eta_b - 1/eta_m)*h_tilde + kbh_t - ((eta_m-1)/eta_m)*h);   //kbh_t = ab_t 
psi4_hat = (psi4/(1+psi4))*(psi_hat - (1/eta_b)*bf + (1/eta_b - 1/eta_m)*h_tilde -(ab/(1-ab))*kbh_t - ((eta_m-1)/eta_m)*h);
h = h_ss^(-(eta_m-1)/eta_m)*((km*m_ss)^((eta_m-1)/eta_m)*m + h_tilde_ss^((eta_m-1)/eta_m)*h_tilde); 
h_tilde = (h_tilde_ss/kbh)^(-(eta_b-1)/eta_b)*(ab*bh_ss^((eta_b-1)/eta_b)*bh + (1-ab)*bf_ss^((eta_b-1)/eta_b)*bf + (eta_b/(eta_b-1))*ab*(bh_ss^((eta_b-1)/eta_b) - bf_ss^((eta_b-1)/eta_b))*kbh_t); 

psi_star_hat = alpha1*c_star + (1-alpha1)*h_star; 
psi1_star_hat = (psi1_star/(1+psi1_star))*(psi_star_hat - c_star); 
psi2_star_hat = (psi2_star/(1+psi2_star))*(psi_star_hat - (1/eta_m)*m_star + ((eta_m-1)/eta_m)*km_star_t - ((eta_m-1)/eta_m)*h_star); 
psi3_star_hat = (psi3_star/(1+psi3_star))*(psi_star_hat - (1/eta_b)*bf_star + (1/eta_b - 1/eta_m)*h_star_tilde + ((eta_b-1)/eta_b)*kbf_star_t - ((eta_m-1)/eta_m)*h_star);
psi4_star_hat = (psi4_star/(1+psi4_star))*(psi_star_hat - (1/eta_b)*bh_star + (1/eta_b - 1/eta_m)*h_star_tilde + ((eta_b-1)/eta_b)*kbh_star_t - ((eta_m-1)/eta_m)*h_star);
h_star = h_star_ss^(-(eta_m-1)/eta_m)*((km*m_star_ss)^((eta_m-1)/eta_m)*m_star + h_star_tilde_ss^((eta_m-1)/eta_m)*h_star_tilde); 
h_star_tilde = (h_star_tilde_ss/kbh)^(-(eta_b-1)/eta_b)*(ab*bf_star_ss^((eta_b-1)/eta_b)*(bf_star + kbf_star_t) + (1-ab)*bh_star_ss^((eta_b-1)/eta_b)*(bh_star+kbh_star_t));

//Equilibrium Conditions
mc = phi*yh  - (1+phi)*a + sigma*c - ph_hat + psi1_hat- chi; 
mc_star = phi*yf - (1+phi)*a_star + sigma*c_star -pf_hat +q + psi1_star_hat - chi_star; 
y_ss*php_ss^eta*(yh + eta*ph_hat) = ah*c_ss*c + (gamma/(1-gamma))*Q_ss^eta*c_ss*af*(c_star + eta*q) + (gamma/(1-gamma))*Q_ss^eta*g_star_ss*af*(eta*q+g_star) + ah*g_ss*g + psi_bar*php_ss^(eta-1)*(psi_hat + (eta-1)*ph_hat); 
bh_bar*bh_g +tau_ss*tau + m_ss*(1-1/mon_mult)*m + m_ss*((1+i_ss)/mon_mult-1)*(m(-1)-pi) + m_ss*((1+i_ss)/mon_mult)*i(-1)=bh_bar*(1+i_ss)*(i(-1)-pi+bh_g(-1)) + g_ss*g; 
bf_bar*bf_g + tau_star_ss*tau_star + m_star_ss*(1-1/mon_mult)*m_star + m_star_ss*((1+i_star_ss)/mon_mult-1)*(m_star(-1)-pi_star) + m_star_ss*((1+i_star_ss)/mon_mult)*i_star(-1) = bf_bar*(1+i_star_ss)*(i_star(-1)-pi_star+bf_g(-1)) + g_star_ss*g_star;
m + b_qe =bh_m; 
m_star = bf_m; 
bh_bar*bh_g = bh_m_ss*bh_m + bh_ss*bh + (gamma/(1-gamma))*bh_star_ss*Q_ss*(bh_star+q); 
bf_bar*bf_g = bf_m_ss*bf_m + ((1-gamma)/gamma)*(bf_ss/Q_ss)*(bf -q) + (bf_star_ss)*bf_star; 
lambda_hat = s(+1) - s + i_star - i;  
lambda = s - s(-1) + i_star(-1)-i(-1); 
idiff = i - i_star; 
delta_s = s-s(-1); 
delta_q = q - q(-1); 
yh_bar = (1/k1)*((1+phi)*a - k2*yf-k3*c_star-k4*g-k5*g_star + chi - psi1_hat - k6*psi_hat - k7*psi_star_hat); 
yf_bar = (1/k1_star)*((1+phi)*a_star - k2_star*yh - k3_star*c-k4_star*g-k5_star*g_star + chi_star - psi1_star_hat - k6_star*psi_hat - k7_star*psi_star_hat); 
yh_tilde = yh - yh_bar; 
yf_tilde = yf - yf_bar; 
bh_gy = bh_g-ph_hat-yh;
bf_gy = bf_g - pf_hat - yf + q; 
bhgy_diff = bh_gy - bh_gy(-1); 
(bh_bar - bh_m_ss)*bh_p = bh_bar*bh_g -bh_m_ss*bh_m;  
r = i - pi(+1); 
r_star = i_star - pi_star(+1); 
rdiff = r - r_star; 
bf_gdp = bf - ph_hat - yh; 

//Incomplete market equations
c_ss*c+psi_bar*psi_hat+m_ss*m+bh_ss*bh+bf_ss*bf = w_ss*n_ss*(w + n) - tau_ss*tau + d_ss*d + m_ss*(m(-1) - pi) + bh_ss*(1+i_ss)*(bh(-1)+i(-1) - pi)+bf_ss*(1+i_star_ss)*(bf(-1) + i_star(-1) - pi + s - s(-1)); 
d_ss*d = d_ss*(yh + ph_hat) - d_ss*(lambda_h-1)*mc; 
phi*n = w - sigma*c - psi1/(1+psi1)*psi1_hat; 
yh = n + a; 

itilde  = i - psi3_hat; 
itilde_star  = i_star - psi3_star_hat; 
itilde_diff = itilde - itilde_star; 

delta_y = yh - yh(-1); 
delta_c  = c - c(-1); 
delta_ystar = yf - yf(-1); 
delta_cstar  = c_star - c_star(-1); 
delta_bhg = bh_g - bh_g(-1);
delta_bhgy = bh_gy - bh_gy(-1); 
delta_m = m - m(-1);


//Policy Rules 
i = rho_i*i(-1) +(1-rho_i)*phi_pi*pi + (1-rho_i)*phi_y*yh_tilde + v; 
i_star = rho_i*i_star(-1) + (1-rho_i)*phi_pi_star*pi_star + (1-rho_i)*phi_y_star*yf_tilde + (1-rho_i)*phi_b*bf_g+ v_star; 
(tau_ss/(php_ss*y_ss))*(tau -ph_hat-yh) = rho_tau*(tau_ss/(php_ss*y_ss))*(tau(-1) -ph_hat(-1) -yh(-1)) + (1-rho_tau)*k_tau1*(bh_bar/(php_ss*y_ss))*(bh_g(-1)-ph_hat(-1)-yh(-1))+(1-rho_tau)*k_tauy*yh+(1-rho_tau)*k_taug*g_ss*g+vtau;  
(tau_star_ss/((pfp_ss/Q_ss)*y_ss))*(tau_star -pf_hat+q-yf) = rho_tau_star*(tau_star_ss/((pfp_ss/Q_ss)*y_ss))*(tau_star(-1) -pf_hat(-1)+q(-1)-yf(-1))+(1-rho_tau_star)*k_tau1_star*(bf_bar/((pfp_ss/Q_ss)*y_ss))*(bf_g(-1)-pf_hat(-1) + q(-1) -yf(-1))+(1-rho_tau_star)*k_tauy_star*yf+(1-rho_tau_star)*k_taug_star*g_star_ss*g_star+vtau_star; 

//Exogenous States Law of Motion 
a = rho_a*a(-1) +rho_aastar*a_star(-1) + eps_a;  
a_star = rho_astar*a_star(-1) +rho_aastar*a(-1) + eps_astar;

v = rho_v*v(-1) + rho_vvstar*v_star(-1) + eps_v; 
v_star = rho_vstar*v_star(-1) + rho_vvstar*v(-1) + eps_vstar;  

u =0; 
u_star =0;  
vtau = rho_vtau*vtau(-1) + rho_vvtaustar*vtau_star(-1)+eps_vtau; 
vtau_star = rho_vtaustar*vtau_star(-1) + rho_vvtaustar*vtau(-1)+eps_vtaustar; 

g = 0; 
g_star = 0; 

chi = 0; 
chi_star = 0; 

b_qe = 0; 

km_t =0; 
kbh_t = 0;
kbf_t= 0;
km_star_t=0;
kbh_star_t= 0;
kbf_star_t= 0; 

end;

initval;
pi_h = 0; 
pi_f = 0; 
pi = 0; 
pi_star = 0; 
s=0;
q =0; 
tot =0; 
mc = 0; 
mc_star = 0; 
ph_hat = 0; 
pf_hat =0; 
i = 0; 
i_star = 0; 
c =0; 
m = 0;
bh=0; 
bf = 0; 
c_star = 0; 
m_star = 0; 
bf_star =0; 
bh_star =0; 
bh_m = 0; 
bf_m = 0; 
lambda_hat = 0; 
psi_hat = 0; 
idiff =0; 
d = 0; 
end;

steady; 

model_diagnostics; 
check; // Checks stability of the system

shocks;
var eps_a = sigma_a^2;
var eps_astar = sigma_astar^2;
var eps_a,eps_astar = sigma_aastar^2; 

var eps_v = sigma_v^2; 
var eps_vstar = sigma_vstar^2; 
var eps_v,eps_vstar = sigma_vvstar^2; 

var eps_vtau = sigma_vtau^2; 
var eps_vtaustar = sigma_vtaustar^2; 
var eps_vtau,eps_vtaustar = sigma_vvtaustar^2; 
end;

stoch_simul(irf = 60, order = 1, nograph);
//noprint; - this will stop any printing to the display  
//nograph - this will stop the generation of graphs. 
