[kaopen, kaopen_str] = xlsread('kaopen_2011.xls',1);

[s,s_str] = xlsread('daily_FX_datastream.xlsx',1);
[f,f_str] = xlsread('daily_FX_datastream.xlsx',2);
[f3m,f3m_str] = xlsread('daily_FX_datastream3m.xlsx',2);
%[cp,cp_str] = xlsread('CP_matlab_weekly.xlsx',1); %%% Commercial Paper Outstanding

[debt_quart,debt_quart_str] = xlsread('USDebt_FRED.xlsx',1); %%% Debt to GDP FRED
debt_quart = debt_quart(:,2:end);

[cp,cp_str] = xlsread('CP_matlab_012016.xlsx',1); %%% Commercial Paper Outstanding
[gdp,gdp_str] = xlsread('US_GDP_FRED.xls',1);
gdp = gdp(:,2:end); 

[infl,infl_str] = xlsread('inflation_OECD.xlsx',1);
infl = infl(2:end,:);

[cpi_wb,cpi_str_wb] = xlsread('WB_CPI.xlsx',1);
cpi_wb = cpi_wb(:,2:end);

vix = xlsread('vix.xlsx');

[debt_int_quart,debt_int_str] = xlsread('Int_Debt_OECD.xlsx');

debt_int_quart = debt_int_quart(:,2:end);

[gdp_int , gdp_int_str] = xlsread('GDP_OECD.xlsx'); 

%%% Tax to GDP
[tax_gdp,tax_gdp_str] = xlsread('TaxGDP_OECD.xlsx');


%%%% MSCI Indecies
[msci, mssci_str] = xlsread('MSCI_Indicies_Datastream.xlsx');
msci = msci(:,2:end);


%%%% NFA 
[assets, assets_str] = xlsread('Assets_FRED.xlsx'); 
assets = assets(1:end-3,2); 

[liab, liab_str] = xlsread('Liabilities_FRED.xlsx'); 
liab = liab(1:end-3,2); 


nfa_us = assets - liab; 
nfa_us = repmat(nfa_us', 4,1); 
nfa_us = nfa_us(:); 
nfa_us = nfa_us(1:end-1); 

%%%% Additional US Interest Rates
[conv_us_data, convus_data_str] = xlsread('US_assetret_Datastream.xlsx');

tbill = log(conv_us_data(:,2));
eurod = log(conv_us_data(:,3));
cp_rate =log( conv_us_data(:,4));
cp_a2 = log(conv_us_data(:,5));
cd = log(conv_us_data(:,6));
prime_rate = log(conv_us_data(:,7));
tenyr_tr = log(conv_us_data(:,8));
sp500_ret  = conv_us_data(:,9);
aaa  = conv_us_data(:,10);
baa  = conv_us_data(:,11);

%%% Additional Foreign Interest rates (Global Financial Database)

[tr3m, tr3m_str ] = xlsread('3mTbill_GFD_data.xlsx',2);
[tr1y, tr1y_str ] = xlsread('1yTbill_GFD_data.xlsx',2);
[tr10y, tr10y_str ] = xlsread('10yTbill_GFD_data.xlsx',2);

tr3m = tr3m(:,2:end);
tr1y = tr1y(:,2:end);
tr10y = tr10y(:,2:end);



fx_country_index = s(1,2:end);
d = s(2:end,1);

s = s(:,2:end);
f = f(:,2:end);
f3m = f3m(:,2:end);
cp = cp(2:end,2:end);

s = log(s(2:end,:)); %%% Log exchange rates
s_ls = s;
f = log(f(2:end,:));
f_ls = f;

f3m = log(f3m(2:end,:));
f3m_ls = f3m;



currency_names = {'AUD','ATS','BEF','CAD','DKK','EUR','FRF','DEM','IEP','ITL','JPY','NLG','NOK','NZD','PTE','ESP','SEK','CHF','GBP','ZAR'};

%s(:,1) = s(:,1)./s(:,12); 
%f(:,1) = f(:,1)./f(:,12); 

%% Preparing the data

date_diff = 693960; %%%% date number difference between Excel and MATLAB convention
dates = datevec(d + 693960);
eur_ind = [2,3,7,8,9,10,12,15,16]; %%% These are the countries in the sample who adopt the EUR.
eur_ind2 = [2,3,7,9,10,12,15,16]; %%% These are the countries in the sample who adopt the EUR, except for Germany
lsnoneur_ind = [1,4,5,8,11,13,14,17,18,19];
eur_indls = [2,3,6,8,9,11,14,15];
eur_start = find(dates(:,1) == 1999,1,'first'); %%% Finds the index for Jan 1999 the date of EUR adoption
s(eur_start:end,eur_ind) = NaN;    %%% Kill off the EUR adopting currencies after Dec 1998
s_ls(eur_start:end,eur_ind2) = NaN; %%% Kill off EUR adopting countries except for Germany
f_ls(eur_start:end,eur_ind2) = NaN;

%%% Constructing VIX series at same dates as currency observations
dates_vix = vix(:,1);
vix_start = find(dates(:,1) == 1990,1,'first')+1;
dates_vix = dates_vix; + (datenum(dates(vix_start,:)) - vix(1));
temp_vix = NaN(length(s),1);


for i = vix_start: length(s)
    if sum(d(i) == dates_vix)
        
        temp_vix(i) = vix(find(d(i) == dates_vix),2);
    end
end
vix = temp_vix;


mean_kaopen76 = nanmean(kaopen(2:end,8:end),2); %%% Taking the mean from 1976 till today

mean_kaopen76_eur = nanmean(kaopen(2:end,8:30),2); %%% Taking the mean from 1976 till EUR inception

fx_kaopen = NaN(size(s,2),7);
kaopen_country_index = kaopen(2:end,1);


for i = 1:length(fx_kaopen)
    if i == 6 %%% This is the index for EUR currency
        continue 
     
    else
        if sum(i == eur_ind) > 0
            fx_kaopen(i,1) = mean_kaopen76_eur(fx_country_index(i) == kaopen_country_index);
                       
        else
            
            fx_kaopen(i,1) = mean_kaopen76(fx_country_index(i) == kaopen_country_index);
     
            
        end
        
        
    end
end


%%%%%%% Central Bank Independence Indices of Arnone, Laurens, Segalotto (2006)
gmt_polaut = NaN(18,2);  %%% Central Bank Index Political Autonomy from Arnone, Laurens, Segalotto (2006). Column 1 is 1991, Column 2 is 2003.
gmt_polaut = [ 3, 2 ;
    3, 8;
    1, 8;
    4, 3;
    3, 4;
    2, 8;
    6, 8;
    3, 8;
    4, 8;
    1, 1;
    6, 8;
    NaN, NaN;
    0, 2;
    1, 8;
    2, 8;
    NaN, NaN;
    5, 7;
    1, 3];

gmt_ecaut = NaN(18,2);  %%% Central Bank Index Economics Autonomy from Arnone, Laurens, Segalotto (2006). Column 1 is 1991, Column 2 is 2003.
gmt_ecaut = [  6, 8;
    6, 7;
    6, 7;
    7, 7;
    5, 8;
    5, 7;
    7, 6;
    4, 5;
    1, 5;
    5, 6;
    4, 6;
    NaN, NaN;
    3, 5;
    2, 5;
    3, 6;
    NaN, NaN;
    7, 8;
    5, 7];

cbi1 = nanmean([nanmean(gmt_polaut,2),nanmean(gmt_ecaut,2)],2);
cbi1(eur_indls) = nanmean([gmt_polaut(eur_indls,1),gmt_ecaut(eur_indls,1)],2);  %%% Euro-legacies -- apply CB rating for 1991 only
cbi1([1,13]) =  nanmean([gmt_polaut([1,13],1),gmt_ecaut([1,13],1)],2)*1/3 + nanmean([gmt_polaut([1,13],2),gmt_ecaut([1,13],2)],2)*2/3;  %%% AUD and NZD available since 1984, so put 2/3rds weight on 2001 measurement
cbi1 = [cbi1(1:5);NaN; cbi1(6:end);NaN];


inclusion_index_mean = [1:20]'; %%% Do not exclude South Africa
inclusion_index_ls = [1:5,7:19]';

inclusion_index_noeurs_ls = [1,4,5,7,10,12,13,16,17,18];


always_open_index = [4,8,11,12,18,19];
always_open_ls = [4,7,10,11,17,18];

min_cutoff = 1;
inclusion_index_min76 = find(fx_kaopen(:,1) > min_cutoff);
inclusion_index_minls76 = inclusion_index_min76(inclusion_index_min76 ~=6);

[~,temp] = sort(fx_kaopen(inclusion_index_ls,1));
inclusion_index_top76 = [4,8,11,12,18,19];
inclusion_index_med76 = [1,2,3,5,13,14,17];
inclusion_index_tophalf76 = [4,5,8,11,12,14,17,18,19];

inclusion_index_no76 =  find(fx_kaopen(:,1) <= min_cutoff);
inclusion_index_nols76 = inclusion_index_no76(inclusion_index_no76 ~= 6);
inclusion_index_nosals76 = inclusion_index_no76(inclusion_index_no76 ~= 20);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Inflation
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

cutoff = 50;

cpi_infl = log(cpi_wb(2:end,:)) - log(cpi_wb(1:end-1,:));
%cpi_infl(1:8, [1,13]) = NaN;

cpi_infl = [cpi_infl(:,1:5),NaN(length(cpi_infl),1), cpi_infl(:,6:end), NaN(length(cpi_infl),1)];

fx_infl_mean_wb = nanmean(cpi_infl)'*100;
fx_infl_std_wb = nanstd(cpi_infl)'*100;

inclusion_index_lowcpiinfl = find(fx_infl_mean_wb(:,1) < prctile(fx_infl_mean_wb(:,1),cutoff));
inclusion_index_highcpiinfl = find(fx_infl_mean_wb(:,1) > prctile(fx_infl_mean_wb(:,1),cutoff));
inclusion_index_lowestcpiinfl = find(fx_infl_mean_wb(:,1) < prctile(fx_infl_mean_wb(:,1), 100 -cutoff));
inclusion_index_midcpiinfl =find((fx_infl_mean_wb(:,1) >= prctile(fx_infl_mean_wb(:,1), 100 -cutoff)).*(fx_infl_mean_wb(:,1) <= prctile(fx_infl_mean_wb(:,1),cutoff)) ==1);

inclusion_index_lcpistd = find(fx_infl_std_wb(:,1) < prctile(fx_infl_std_wb(:,1),cutoff));
inclusion_index_hcpistd = find(fx_infl_std_wb(:,1) > prctile(fx_infl_std_wb(:,1),cutoff));
inclusion_index_lowestcpistd = find(fx_infl_std_wb(:,1) < prctile(fx_infl_std_wb(:,1), 100 -cutoff));
inclusion_index_midcpistd =find((fx_infl_std_wb(:,1) >= prctile(fx_infl_std_wb(:,1), 100 -cutoff)).*(fx_infl_std_wb(:,1) <= prctile(fx_infl_std_wb(:,1),cutoff)) ==1);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   CBI
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

cutoff = 50;
inclusion_index_highcbi1 = find(cbi1 >= prctile(cbi1, cutoff));
inclusion_index_lowcbi1 = find(cbi1 < prctile(cbi1,cutoff));
inclusion_index_highestcbi1 = find(cbi1(:,1) >= prctile(cbi1, 100 -cutoff));
inclusion_index_midcbi1 =find((cbi1(:,1) >= prctile(cbi1(:,1), cutoff)).*(cbi1(:,1) <= prctile(cbi1(:,1),100-cutoff)) ==1);

%%% Constructing Interest Rate Differentials

i_diff =  f - s;
i_diff_ls = f_ls - s_ls;
i_diff3m_ls = f3m_ls - s_ls;



%%% Intersection of top and bottom bins for Section 6.C
temp1 = intersect(inclusion_index_tophalf76, inclusion_index_lcpistd);
temp2 = intersect(temp1, inclusion_index_highcbi1);
intersect_high = intersect(temp2, inclusion_index_lowcpiinfl); 

temp1_low = intersect(inclusion_index_nosals76, inclusion_index_highcpiinfl); 
temp2_low = intersect(temp1_low, inclusion_index_hcpistd); 
intersect_low = intersect(temp2_low, inclusion_index_lowcbi1); 

%%% Mean Openness cutoffs
s_ls76 = s_ls(:,inclusion_index_ls);


i_diff_ls76 = i_diff_ls(:,inclusion_index_ls);
i_diff3m_ls76 = i_diff3m_ls(:,inclusion_index_ls);

%%% Min Openness cutoffs
s_minls76 = s_ls(:,inclusion_index_minls76);

i_diff_minls76 = i_diff_ls(:,inclusion_index_minls76);
i_diff3m_minls76 = i_diff3m_ls(:,inclusion_index_minls76);

%%% Not Financially Open
s_nosals76 = s_ls(:,inclusion_index_nosals76);
i_diff_nosals76 = i_diff_ls(:,inclusion_index_nosals76);


%%% Excess Returns
return_ind = 0;
return_ind3m = 0;

for i = 1:length(d)
    [discr,temp_ind]= min(abs(d -d(i) - 30));
    return_ind(i) = temp_ind;
    if d(end) - d(i)-30<0
        break
    end
end

for i = 1:length(d)
    [discr,temp_ind]= min(abs(d -d(i) - 90));
    return_ind3m(i) = temp_ind;
    if d(end) - d(i)-90<0
        break
    end
end


lambda_ls76 = s_ls76(return_ind,:) - s_ls76(1:length(return_ind),:) - i_diff_ls76(1:length(return_ind),:);
lambda_minls76 = s_minls76(return_ind,:) - s_minls76(1:length(return_ind),:) - i_diff_minls76(1:length(return_ind),:);
lambda_nosals76 = s_nosals76(return_ind,:) - s_nosals76(1:length(return_ind),:) - i_diff_nosals76(1:length(return_ind),:);


deltas_ls76 = s_ls76(return_ind,:) - s_ls76(1:length(return_ind),:);


%%% Debt variables


%%% Fill in with old values
debt = NaN(length(i_diff_ls76),1);      %%% US Federal Debt in Public hands -- FRED database
debt_int = NaN(length(i_diff_ls76),size(debt_int_quart,2));

cp_gdp = NaN(length(debt),size(cp,2));

nfa    = NaN(size(debt)); 
nfa_gdp    = NaN(size(debt)); 

quart_count = 1;
month_count = 1;

infl_daily = NaN(length(debt),1); 

for i = 2:length(debt)
    
    if sum( (dates(i,2) == [1,4,7,10]) )==1  && sum(dates(i-1,2) == [12,3,6,9]) ==1
        quart_count = quart_count +1;
    end
    
    if dates(i,2) > dates(i-1,2) || dates(i,2) - dates(i-1,2) == -11
        month_count = month_count +1;
    end
    

    
    nfa(i)  = nfa_us(quart_count,1); 
    nfa_gdp(i) = nfa_us(quart_count,1)/(1000*gdp(quart_count)); 
    
    if quart_count < 2
        continue
    else
        
        debt(i) = debt_quart(quart_count - 1,1);    
        debt_int(i,:) = debt_int_quart(quart_count-1,:);
  
    end
    
    if month_count < 2
        continue
    else
        cp_gdp(i,:) = cp(month_count-1,:)./gdp(quart_count);
    end
    
    infl_daily(i) = infl(month_count,19); 
end

%%%% Stock market volatility

vol12m = NaN(length(sp500_ret),1);

for i = 264:length(vol12m)
    
    vol12m(i) = nanstd(sp500_ret(i-263:i));
    
end

%%%% International Stock Market volatility

msci_ret = log(msci(2:end,:)) - log(msci(1:end-1,:)); 
msci_ret = [NaN(1,19); msci_ret]; 

vol12m_int = NaN(size(msci_ret));

for j = 1:size(vol12m_int,2)
    
    for i = 264:length(vol12m_int)
        
        vol12m_int(i,j) = nanstd(msci_ret(i-263:i,j));
        
    end
    
end

%%  Pairwise UIP regressions at horizons from 1 to 180 months 


alpha = 0.05;
z_crit = norminv(1-alpha/2,0,1);

alpha = 0.1;
z_crit90 = norminv(1-alpha/2,0,1);

start_d = 1;
end_d = 8348;   %%% End the sample on 12/31/2007 to avoid financial crisis (benchmark estiamtes; to replicate appendix, set end_d = length(s_ls76)

periods  = 180;

bl_prof_76 = NaN(periods, size(s_ls76,2));
bl_minint_prof_76 = NaN(periods, size(s_ls76,2));
bl_maxint_prof_76 = NaN(periods, size(s_ls76,2));
rho_lr_prof_76 = NaN(periods,size(s_ls76,2));
Rsq_lprof_76 = NaN(periods,size(s_ls76,2));
tl_76 = NaN(periods, size(s_ls76,2)); 



parfor i = 1:size(lambda_ls76,2)
    
    lambda_temp = lambda_ls76(:,i); 
    idiff_temp  = i_diff_ls76(:,i); 
    for j = 1:periods
       
        j_ind = 0;
        for ii=start_d:end_d
            
            [discr,temp_ind]= min(abs(d -d(ii) - 30*(j-1)));
            if temp_ind > end_d %length(lambda_ls76)
                break
            end
            j_ind(ii-start_d+1) = temp_ind;
     
        end
        j_ind = j_ind';
              
        [b,bint,r,~,stats]  = regress(lambda_temp(j_ind),[ones(length(lambda_temp(j_ind)),1),idiff_temp(start_d:length(j_ind))]);

        bl_prof_76(j,i) = b(2);
        al_prof_76(j,i) = b(1);
        Rsq_lprof_76(j,i) = stats(1);
        
        se = (bint(2,2) - b(2))/z_crit; 
        bl_min =b(2) - z_crit*se;
        bl_max = b(2) + z_crit*se;
    
    
        tl_76(j,i) = bl_prof_76(j,i)/se;
        
   
    end
    i;
end

%% Put data in state format for panel regressions 
periods = 180;

headers = cell(1,periods + 3);
headers{1} = 'countryid';
headers{2} = 'time';

for i = 1:periods
    headers{i+2} = strcat('sdiff',num2str(i));
    headers{2 + periods +i} = strcat('sj', num2str(i)); 
    headers{2 + 2*periods +i} = strcat('deltas', num2str(i)); 
    headers{2 + 3*periods + i} = strcat('idiff_prof',num2str(i)); 
end



headers{4*periods + 3} = 'idiff';


headers{4*periods + 4} = 'Debt';
headers{4*periods + 5} = 'CP';
headers{4*periods + 6} = 'vix';
headers{4*periods + 7} = 'int debt';
headers{4*periods + 8} = 'yield_sl_us';
headers{4*periods + 9} = 'yield_sl_int';
headers{4*periods + 10} = 'vol12m';
headers{4*periods + 11} = 'vol12m int';
headers{4*periods + 12} = 'nfa_gdp';
headers{4*periods + 13} = 'aaa';
headers{4*periods + 14} = 'baa';
headers{4*periods + 15} = 'treasury';


start_d = 1; 

whole_sample = [1:18];

sdiff_ls76 = NaN((size(lambda_ls76,1))*size(lambda_ls76(:,whole_sample),2),periods);
sdiff2_ls76 = NaN((size(lambda_ls76,1))*size(lambda_ls76(:,whole_sample),2),periods);
idiff_prof_ls76 = sdiff_ls76; 

temp = lambda_ls76(:,whole_sample);
sdiff_ls76(:,1) = temp(:);
sdiff2_ls76(:,1) = deltas_ls76(:);
temp = i_diff_ls76(1:length(return_ind),:); 
idiff_prof_ls76(:,1)  = temp(:); 

for j = 1:periods-1
    stata_ind = 0;
    for i=1:length(d)
        
        [discr,temp_ind]= min(abs(d -d(i) - 30*j));
        if temp_ind > length(lambda_ls76)
            break
        end
        stata_ind(i) = temp_ind;
    end
    
    sdiff_temp = NaN(size(lambda_ls76(:,whole_sample)));
    sdiff_temp(1:length( lambda_ls76(stata_ind,whole_sample)),:) = lambda_ls76(stata_ind,whole_sample);
    sdiff_ls76(:,j+1) = sdiff_temp(:);
    
    sdiff_temp2 = NaN(size(lambda_ls76));
    sdiff_temp2(1:length( lambda_ls76(stata_ind,:)),:) = deltas_ls76(stata_ind,:);
    sdiff2_ls76(:,j+1) = sdiff_temp2(:);
        
    idiff_temp = NaN(size(lambda_ls76));
    idiff_temp(1:length( lambda_ls76(stata_ind,:)),:) = i_diff_ls76(stata_ind,:);
    idiff_prof_ls76(:,j+1) = idiff_temp(:);
    
    j;
end

idiff_76_stata = NaN(size(i_diff_ls76(1:length(return_ind),whole_sample)));
idiff_76_stata(start_d:end,:) =  i_diff_ls76(start_d:length(return_ind),whole_sample);

%%%%% sj - s 
sj_ls76 = NaN((size(lambda_ls76,1))*size(lambda_ls76,2),periods);
for j = 1:periods
    sj_ls76(:,j) = sum(sdiff2_ls76(:,1:j),2);
    
end



psi_ls76 = NaN(size(sdiff_ls76,1),9);


%%% Debt
psi_temp = log(debt(1:length(return_ind))/100)/100;
psi_temp(1:start_d-1) = NaN;
psi_ls76(:,1) = repmat(psi_temp,size(s_ls76(:,whole_sample),2),1);

%%% CP
psi_temp = log(cp_gdp(1:length(return_ind),2)/100)/100;
psi_temp(1:start_d-1) = NaN;
psi_ls76(:,2) = repmat(psi_temp,size(s_ls76(:,whole_sample),2),1);

%%% VIX
psi_temp = -bsxfun(@times,vix(1:length(return_ind)),sign(i_diff_ls76(1:length(return_ind),whole_sample))/100);
psi_temp(1:start_d-1) = NaN;
psi_ls76(:,3) = psi_temp(:);

%%% Int Debt
psi_temp = log(debt_int(1:length(return_ind),whole_sample)/100)/100;
psi_temp(1:start_d-1,:) = NaN;
psi_ls76(:,4) = psi_temp(:);

%%% US Yield Curve Slope
slope = 400*(tenyr_tr - tbill);
psi_temp = slope(1:length(return_ind));
psi_temp(1:start_d-1) = NaN;
psi_ls76(:,5) = repmat(psi_temp,size(s_ls76(:,whole_sample),2),1);

%%% Foreign Yield Curve Slope
slope_star = tr10y - tr3m;
psi_temp = slope_star(1:length(return_ind),whole_sample);
psi_temp(1:start_d-1,:) = NaN;
psi_ls76(:,6) = psi_temp(:);

%%% Vol12m
vol_temp = vol12m*sqrt(264);
psi_temp = vol_temp(1:length(return_ind));
psi_temp(1:start_d-1) = NaN;
psi_ls76(:,7) = repmat(psi_temp,size(s_ls76(:,whole_sample),2),1);

%%% Vol12m Int
vol_temp = vol12m_int*sqrt(264);
psi_temp = vol_temp(1:length(return_ind),whole_sample);
psi_temp(1:start_d-1) = NaN;
psi_ls76(:,8) = psi_temp(:);

%%% NFA/GDP
psi_temp = nfa_gdp(1:length(return_ind));
psi_temp(1:start_d-1) = NaN;
%[b,bint,r,~,stats]  = regress(psi_temp,[ones(length(psi_temp),1),(1:length(psi_temp))']);
%psi_temp = r;
psi_ls76(:,9) = repmat(psi_temp,size(s_ls76(:,whole_sample),2),1);

%%% AAA
psi_temp = log(aaa(1:length(return_ind)))/3;
psi_temp(1:start_d-1) = NaN;
psi_ls76(:,10) = repmat(psi_temp,size(s_ls76(:,whole_sample),2),1);

%%% Baa
psi_temp = log(baa(1:length(return_ind)))/3;
psi_temp(1:start_d-1) = NaN;
psi_ls76(:,11) = repmat(psi_temp,size(s_ls76(:,whole_sample),2),1);

%%% 10yr Treasury
psi_temp = tenyr_tr(1:length(return_ind))/3;
psi_temp(1:start_d-1) = NaN;
psi_ls76(:,12) = repmat(psi_temp,size(s_ls76(:,whole_sample),2),1);

%}

stata_country_index76 = repmat(fx_country_index(inclusion_index_ls),size(lambda_ls76(:,whole_sample),1),1);
time = repmat([1:size(lambda_ls76,1)]',1,size(lambda_ls76(:,whole_sample),2));
stata_data = [stata_country_index76(:), time(:), sdiff_ls76, sj_ls76, sdiff2_ls76, idiff_prof_ls76, idiff_76_stata(:),psi_ls76];
csvwrite_with_headers('stata_data.csv',stata_data,headers);



