function [residual, g1, g2, g3] = model_solution_incomplete_mkts_static(y, x, params)
%
% Status : Computes static model for Dynare
%
% Inputs : 
%   y         [M_.endo_nbr by 1] double    vector of endogenous variables in declaration order
%   x         [M_.exo_nbr by 1] double     vector of exogenous variables in declaration order
%   params    [M_.param_nbr by 1] double   vector of parameter values in declaration order
%
% Outputs:
%   residual  [M_.endo_nbr by 1] double    vector of residuals of the static model equations 
%                                          in order of declaration of the equations.
%                                          Dynare may prepend or append auxiliary equations, see M_.aux_vars
%   g1        [M_.endo_nbr by M_.endo_nbr] double    Jacobian matrix of the static model equations;
%                                                       columns: variables in declaration order
%                                                       rows: equations in order of declaration
%   g2        [M_.endo_nbr by (M_.endo_nbr)^2] double   Hessian matrix of the static model equations;
%                                                       columns: variables in declaration order
%                                                       rows: equations in order of declaration
%   g3        [M_.endo_nbr by (M_.endo_nbr)^3] double   Third derivatives matrix of the static model equations;
%                                                       columns: variables in declaration order
%                                                       rows: equations in order of declaration
%
%
% Warning : this file is generated automatically by Dynare
%           from model file (.mod)

residual = zeros( 92, 1);

%
% Model equations
%

T15 = (1-params(1))*(1-params(1)*params(2))/params(1);
T37 = params(21)*params(41)^(1-params(11));
T46 = params(20)*params(41)^(params(11)-1);
T85 = params(23)/params(11)*params(13)*params(37)/(params(87)*params(39));
T93 = params(23)/params(11)*params(12)/(params(87)*params(38));
T156 = params(76)/(1+params(76));
T162 = params(77)/(1+params(77));
T164 = 1/params(113);
T169 = (params(113)-1)/params(113);
T179 = params(78)/(1+params(78));
T181 = 1/params(112);
T187 = (T181-T164)*y(64);
T196 = params(79)/(1+params(79));
T212 = params(117)^((-(params(113)-1))/params(113));
T216 = (params(116)*params(95))^T169;
T219 = params(119)^T169;
T229 = (params(119)/params(114))^((-(params(112)-1))/params(112));
T231 = (params(112)-1)/params(112);
T232 = params(101)^T231;
T236 = params(102)^T231;
T261 = params(81)/(1+params(81));
T274 = params(82)/(1+params(82));
T289 = params(83)/(1+params(83));
T301 = params(118)^((-(params(113)-1))/params(113));
T304 = (params(116)*params(96))^T169;
T307 = params(120)^T169;
T313 = (params(120)/params(114))^((-(params(112)-1))/params(112));
T316 = params(111)*params(103)^T231;
T321 = (1-params(111))*params(104)^T231;
T351 = params(87)*params(38)^params(11);
T362 = params(10)/(1-params(10))*params(37)^params(11);
T380 = params(12)*params(38)^(params(11)-1);
T403 = params(95)*((1+params(93))/params(34)-1);
T431 = params(96)*((1+params(94))/params(34)-1);
T465 = (1-params(10))/params(10)*params(102)/params(37);
T486 = 1/params(135);
T511 = 1/params(141);
T670 = params(84)/(params(87)*params(38));
T681 = (1-params(105))*params(8)*params(91)/(params(87)*params(38));
T698 = params(85)/(params(87)*params(39)/params(37));
T710 = (1-params(106))*params(16)*params(92)/(params(87)*params(39)/params(37));
lhs =y(1);
rhs =T15*y(11)+y(1)*params(2)+y(48);
residual(1)= lhs-rhs;
lhs =y(2);
rhs =T15*y(12)+params(2)*y(2)+y(49);
residual(2)= lhs-rhs;
lhs =y(3);
rhs =y(1);
residual(3)= lhs-rhs;
lhs =y(4);
rhs =y(2)+y(14)-y(14);
residual(4)= lhs-rhs;
lhs =y(13);
rhs =params(128)*y(20)+params(129)*y(21)+params(130)*y(22)+params(131)*y(26)+params(144)*y(52)+params(145)*y(53)+T85*y(54)-T93*y(8);
residual(5)= lhs-rhs;
lhs =y(15);
rhs =y(13)*(-(T37/(T37+params(20))));
residual(6)= lhs-rhs;
lhs =y(16);
rhs =y(13)*T46/(params(21)+T46);
residual(7)= lhs-rhs;
lhs =y(14);
rhs =y(13)*params(22);
residual(8)= lhs-rhs;
lhs =y(3)+y(14)-y(14);
rhs =y(4)+y(5)-y(5);
residual(9)= lhs-rhs;
lhs =0;
rhs =y(3)+y(58);
residual(10)= lhs-rhs;
lhs =0;
rhs =y(3)-y(17)+y(9);
residual(11)= lhs-rhs;
lhs =0;
rhs =y(5)+y(3)-y(18)-y(5)+y(10);
residual(12)= lhs-rhs;
lhs =0;
rhs =y(4)+y(60);
residual(13)= lhs-rhs;
lhs =0;
rhs =y(4)-y(18)+y(61);
residual(14)= lhs-rhs;
lhs =0;
rhs =y(5)+y(4)-y(17)-y(5)+y(62);
residual(15)= lhs-rhs;
lhs =y(8);
rhs =y(22)*params(28)+(1-params(28))*y(63);
residual(16)= lhs-rhs;
lhs =y(57);
rhs =T156*(y(8)-y(22));
residual(17)= lhs-rhs;
lhs =y(58);
rhs =T162*(y(8)-T164*y(23)+T169*y(67)-y(63)*T169);
residual(18)= lhs-rhs;
lhs =y(9);
rhs =T179*(y(8)-T181*y(24)+T187+y(68)-y(63)*T169);
residual(19)= lhs-rhs;
lhs =y(10);
rhs =T196*(T187+y(8)-T181*y(25)-y(68)*params(111)/(1-params(111))-y(63)*T169);
residual(20)= lhs-rhs;
lhs =y(63);
rhs =T212*(y(23)*T216+y(64)*T219);
residual(21)= lhs-rhs;
lhs =y(64);
rhs =T229*(y(24)*params(111)*T232+y(25)*(1-params(111))*T236+y(68)*params(111)*params(112)/(params(112)-1)*(T232-T236));
residual(22)= lhs-rhs;
lhs =y(54);
rhs =y(26)*params(28)+(1-params(28))*y(65);
residual(23)= lhs-rhs;
lhs =y(59);
rhs =params(80)/(1+params(80))*(y(54)-y(26));
residual(24)= lhs-rhs;
lhs =y(60);
rhs =T261*(y(54)-T164*y(27)+T169*y(70)-T169*y(65));
residual(25)= lhs-rhs;
lhs =y(61);
rhs =T274*(y(54)-T181*y(28)+(T181-T164)*y(66)+T231*y(72)-T169*y(65));
residual(26)= lhs-rhs;
lhs =y(62);
rhs =T289*((T181-T164)*y(66)+y(54)-T181*y(29)+T231*y(71)-T169*y(65));
residual(27)= lhs-rhs;
lhs =y(65);
rhs =T301*(y(27)*T304+y(66)*T307);
residual(28)= lhs-rhs;
lhs =y(66);
rhs =T313*(T316*(y(28)+y(72))+T321*(y(29)+y(71)));
residual(29)= lhs-rhs;
lhs =y(11);
rhs =y(57)+y(20)*params(4)-(1+params(4))*y(44)+y(22)*params(3)-y(15)-y(55);
residual(30)= lhs-rhs;
lhs =y(12);
rhs =y(59)+y(14)+y(21)*params(4)-(1+params(4))*y(45)+y(26)*params(3)-y(16)-y(56);
residual(31)= lhs-rhs;
lhs =T351*(y(20)+params(11)*y(15));
rhs =y(22)*params(20)*params(86)+params(21)*params(86)*T362*(y(26)+params(11)*y(14))+params(21)*T362*params(89)*(y(53)+params(11)*y(14))+y(52)*params(20)*params(88)+T380*(y(8)+(params(11)-1)*y(15));
residual(32)= lhs-rhs;
lhs =params(91)*y(34)+params(84)*y(36)+y(23)*params(95)*(1-1/params(34))+T403*(y(23)-y(3))+y(17)*params(95)*(1+params(93))/params(34);
rhs =params(91)*(1+params(93))*(y(34)+y(17)-y(3))+y(52)*params(88);
residual(33)= lhs-rhs;
lhs =params(92)*y(35)+params(85)*y(37)+y(27)*params(96)*(1-1/params(34))+T431*(y(27)-y(4))+y(18)*params(96)*(1+params(94))/params(34);
rhs =params(92)*(1+params(94))*(y(35)+y(18)-y(4))+y(53)*params(89);
residual(34)= lhs-rhs;
lhs =y(23)+y(73);
rhs =y(32);
residual(35)= lhs-rhs;
lhs =y(27);
rhs =y(33);
residual(36)= lhs-rhs;
lhs =params(91)*y(34);
rhs =y(32)*params(35)+y(24)*params(101)+params(37)*params(104)*params(10)/(1-params(10))*(y(14)+y(29));
residual(37)= lhs-rhs;
lhs =params(92)*y(35);
rhs =y(33)*params(36)+T465*(y(25)-y(14))+y(28)*params(103);
residual(38)= lhs-rhs;
lhs =y(7);
rhs =y(18)-y(17);
residual(39)= lhs-rhs;
lhs =y(6);
rhs =y(18)-y(17);
residual(40)= lhs-rhs;
lhs =y(19);
rhs =y(17)-y(18);
residual(41)= lhs-rhs;
residual(42) = y(92);
residual(43) = y(91);
lhs =y(38);
rhs =T486*(y(55)+(1+params(4))*y(44)-y(21)*params(136)-y(26)*params(137)-y(52)*params(150)-y(53)*params(151)-y(57)-y(8)*params(123)-y(54)*params(124));
residual(44)= lhs-rhs;
lhs =y(39);
rhs =T511*(y(56)+(1+params(4))*y(45)-y(20)*params(142)-y(22)*params(143)-y(52)*params(152)-y(53)*params(153)-y(59)-y(8)*params(125)-y(54)*params(126));
residual(45)= lhs-rhs;
lhs =y(40);
rhs =y(20)-y(38);
residual(46)= lhs-rhs;
lhs =y(41);
rhs =y(21)-y(39);
residual(47)= lhs-rhs;
lhs =y(30);
rhs =y(34)-y(15)-y(20);
residual(48)= lhs-rhs;
lhs =y(31);
rhs =y(14)+y(35)-y(16)-y(21);
residual(49)= lhs-rhs;
residual(50) = y(42);
lhs =(params(91)-params(35))*y(43);
rhs =params(91)*y(34)-y(32)*params(35);
residual(51)= lhs-rhs;
lhs =y(87);
rhs =y(17)-y(3);
residual(52)= lhs-rhs;
lhs =y(88);
rhs =y(18)-y(4);
residual(53)= lhs-rhs;
lhs =y(81);
rhs =y(87)-y(88);
residual(54)= lhs-rhs;
lhs =y(74);
rhs =y(25)-y(15)-y(20);
residual(55)= lhs-rhs;
lhs =y(24)*params(101)+y(22)*params(86)+params(12)*y(8)+y(23)*params(95)+y(25)*params(102);
rhs =params(158)*params(159)*(y(77)+y(76))-params(84)*y(36)+params(160)*y(75)+params(95)*(y(23)-y(3))+params(101)*(1+params(93))*(y(17)+y(24)-y(3))+params(102)*(1+params(94))*(y(5)+y(18)+y(25)-y(3)-y(5));
residual(56)= lhs-rhs;
lhs =params(160)*y(75);
rhs =params(160)*(y(20)+y(15))-y(11)*params(160)*(params(18)-1);
residual(57)= lhs-rhs;
lhs =params(4)*y(76);
rhs =y(77)-y(22)*params(3)-y(57)*T156;
residual(58)= lhs-rhs;
lhs =y(20);
rhs =y(44)+y(76);
residual(59)= lhs-rhs;
lhs =y(78);
rhs =y(17)-y(9);
residual(60)= lhs-rhs;
lhs =y(79);
rhs =y(18)-y(61);
residual(61)= lhs-rhs;
lhs =y(80);
rhs =y(78)-y(79);
residual(62)= lhs-rhs;
residual(63) = y(82);
residual(64) = y(83);
residual(65) = y(84);
residual(66) = y(85);
residual(67) = y(86);
residual(68) = y(89);
residual(69) = y(90);
lhs =y(17);
rhs =y(17)*params(5)+y(3)*(1-params(5))*params(6)+y(40)*(1-params(5))*params(7)+y(46);
residual(70)= lhs-rhs;
lhs =y(18);
rhs =y(18)*params(5)+y(4)*(1-params(5))*params(14)+y(41)*(1-params(5))*params(15)+y(35)*(1-params(5))*params(109)+y(47);
residual(71)= lhs-rhs;
lhs =T670*(y(36)-y(15)-y(20));
rhs =(y(36)-y(15)-y(20))*T670*params(105)+(y(34)-y(15)-y(20))*T681+y(20)*(1-params(105))*params(9)+y(52)*params(88)*(1-params(105))*params(107)+y(50);
residual(72)= lhs-rhs;
lhs =T698*(y(14)+y(37)-y(16)-y(21));
rhs =(y(14)+y(37)-y(16)-y(21))*T698*params(106)+T710*(y(14)+y(35)-y(16)-y(21))+y(21)*(1-params(106))*params(17)+y(53)*params(89)*(1-params(106))*params(108)+y(51);
residual(73)= lhs-rhs;
lhs =y(44);
rhs =y(44)*params(42)+y(45)*params(44)+x(1);
residual(74)= lhs-rhs;
lhs =y(45);
rhs =y(45)*params(43)+y(44)*params(44)+x(2);
residual(75)= lhs-rhs;
lhs =y(46);
rhs =y(46)*params(45)+y(47)*params(47)+x(3);
residual(76)= lhs-rhs;
lhs =y(47);
rhs =y(47)*params(46)+y(46)*params(47)+x(4);
residual(77)= lhs-rhs;
residual(78) = y(48);
residual(79) = y(49);
lhs =y(50);
rhs =y(50)*params(51)+y(51)*params(53)+x(5);
residual(80)= lhs-rhs;
lhs =y(51);
rhs =y(51)*params(52)+y(50)*params(53)+x(6);
residual(81)= lhs-rhs;
residual(82) = y(52);
residual(83) = y(53);
residual(84) = y(55);
residual(85) = y(56);
residual(86) = y(73);
residual(87) = y(67);
residual(88) = y(68);
residual(89) = y(69);
residual(90) = y(70);
residual(91) = y(71);
residual(92) = y(72);
if ~isreal(residual)
  residual = real(residual)+imag(residual).^2;
end
if nargout >= 2,
  g1 = zeros(92, 92);

  %
  % Jacobian matrix
  %

T832 = (-(T670*params(105)))-T681;
  g1(1,1)=1-params(2);
  g1(1,11)=(-T15);
  g1(1,48)=(-1);
  g1(2,2)=1-params(2);
  g1(2,12)=(-T15);
  g1(2,49)=(-1);
  g1(3,1)=(-1);
  g1(3,3)=1;
  g1(4,2)=(-1);
  g1(4,4)=1;
  g1(5,8)=T93;
  g1(5,13)=1;
  g1(5,20)=(-params(128));
  g1(5,21)=(-params(129));
  g1(5,22)=(-params(130));
  g1(5,26)=(-params(131));
  g1(5,52)=(-params(144));
  g1(5,53)=(-params(145));
  g1(5,54)=(-T85);
  g1(6,13)=T37/(T37+params(20));
  g1(6,15)=1;
  g1(7,13)=(-(T46/(params(21)+T46)));
  g1(7,16)=1;
  g1(8,13)=(-params(22));
  g1(8,14)=1;
  g1(9,3)=1;
  g1(9,4)=(-1);
  g1(10,3)=(-1);
  g1(10,58)=(-1);
  g1(11,3)=(-1);
  g1(11,9)=(-1);
  g1(11,17)=1;
  g1(12,3)=(-1);
  g1(12,10)=(-1);
  g1(12,18)=1;
  g1(13,4)=(-1);
  g1(13,60)=(-1);
  g1(14,4)=(-1);
  g1(14,18)=1;
  g1(14,61)=(-1);
  g1(15,4)=(-1);
  g1(15,17)=1;
  g1(15,62)=(-1);
  g1(16,8)=1;
  g1(16,22)=(-params(28));
  g1(16,63)=(-(1-params(28)));
  g1(17,8)=(-T156);
  g1(17,22)=T156;
  g1(17,57)=1;
  g1(18,8)=(-T162);
  g1(18,23)=(-(T162*(-T164)));
  g1(18,58)=1;
  g1(18,63)=(-(T162*(-T169)));
  g1(18,67)=(-(T162*T169));
  g1(19,8)=(-T179);
  g1(19,9)=1;
  g1(19,24)=(-(T179*(-T181)));
  g1(19,63)=(-(T179*(-T169)));
  g1(19,64)=(-(T179*(T181-T164)));
  g1(19,68)=(-T179);
  g1(20,8)=(-T196);
  g1(20,10)=1;
  g1(20,25)=(-(T196*(-T181)));
  g1(20,63)=(-(T196*(-T169)));
  g1(20,64)=(-((T181-T164)*T196));
  g1(20,68)=(-(T196*(-(params(111)/(1-params(111))))));
  g1(21,23)=(-(T212*T216));
  g1(21,63)=1;
  g1(21,64)=(-(T212*T219));
  g1(22,24)=(-(T229*params(111)*T232));
  g1(22,25)=(-(T229*(1-params(111))*T236));
  g1(22,64)=1;
  g1(22,68)=(-(T229*params(111)*params(112)/(params(112)-1)*(T232-T236)));
  g1(23,26)=(-params(28));
  g1(23,54)=1;
  g1(23,65)=(-(1-params(28)));
  g1(24,26)=params(80)/(1+params(80));
  g1(24,54)=(-(params(80)/(1+params(80))));
  g1(24,59)=1;
  g1(25,27)=(-(T261*(-T164)));
  g1(25,54)=(-T261);
  g1(25,60)=1;
  g1(25,65)=(-(T261*(-T169)));
  g1(25,70)=(-(T169*T261));
  g1(26,28)=(-(T274*(-T181)));
  g1(26,54)=(-T274);
  g1(26,61)=1;
  g1(26,65)=(-(T274*(-T169)));
  g1(26,66)=(-((T181-T164)*T274));
  g1(26,72)=(-(T231*T274));
  g1(27,29)=(-(T289*(-T181)));
  g1(27,54)=(-T289);
  g1(27,62)=1;
  g1(27,65)=(-(T289*(-T169)));
  g1(27,66)=(-((T181-T164)*T289));
  g1(27,71)=(-(T231*T289));
  g1(28,27)=(-(T301*T304));
  g1(28,65)=1;
  g1(28,66)=(-(T301*T307));
  g1(29,28)=(-(T313*T316));
  g1(29,29)=(-(T313*T321));
  g1(29,66)=1;
  g1(29,71)=(-(T313*T321));
  g1(29,72)=(-(T313*T316));
  g1(30,11)=1;
  g1(30,15)=1;
  g1(30,20)=(-params(4));
  g1(30,22)=(-params(3));
  g1(30,44)=1+params(4);
  g1(30,55)=1;
  g1(30,57)=(-1);
  g1(31,12)=1;
  g1(31,14)=(-1);
  g1(31,16)=1;
  g1(31,21)=(-params(4));
  g1(31,26)=(-params(3));
  g1(31,45)=1+params(4);
  g1(31,56)=1;
  g1(31,59)=(-1);
  g1(32,8)=(-T380);
  g1(32,14)=(-(params(11)*params(21)*params(86)*T362+params(11)*params(21)*T362*params(89)));
  g1(32,15)=params(11)*T351-(params(11)-1)*T380;
  g1(32,20)=T351;
  g1(32,22)=(-(params(20)*params(86)));
  g1(32,26)=(-(params(21)*params(86)*T362));
  g1(32,52)=(-(params(20)*params(88)));
  g1(32,53)=(-(params(21)*T362*params(89)));
  g1(33,3)=(-T403)-(-(params(91)*(1+params(93))));
  g1(33,17)=params(95)*(1+params(93))/params(34)-params(91)*(1+params(93));
  g1(33,23)=params(95)*(1-1/params(34))+T403;
  g1(33,34)=params(91)-params(91)*(1+params(93));
  g1(33,36)=params(84);
  g1(33,52)=(-params(88));
  g1(34,4)=(-T431)-(-(params(92)*(1+params(94))));
  g1(34,18)=params(96)*(1+params(94))/params(34)-params(92)*(1+params(94));
  g1(34,27)=params(96)*(1-1/params(34))+T431;
  g1(34,35)=params(92)-params(92)*(1+params(94));
  g1(34,37)=params(85);
  g1(34,53)=(-params(89));
  g1(35,23)=1;
  g1(35,32)=(-1);
  g1(35,73)=1;
  g1(36,27)=1;
  g1(36,33)=(-1);
  g1(37,14)=(-(params(37)*params(104)*params(10)/(1-params(10))));
  g1(37,24)=(-params(101));
  g1(37,29)=(-(params(37)*params(104)*params(10)/(1-params(10))));
  g1(37,32)=(-params(35));
  g1(37,34)=params(91);
  g1(38,14)=T465;
  g1(38,25)=(-T465);
  g1(38,28)=(-params(103));
  g1(38,33)=(-params(36));
  g1(38,35)=params(92);
  g1(39,7)=1;
  g1(39,17)=1;
  g1(39,18)=(-1);
  g1(40,6)=1;
  g1(40,17)=1;
  g1(40,18)=(-1);
  g1(41,17)=(-1);
  g1(41,18)=1;
  g1(41,19)=1;
  g1(42,92)=1;
  g1(43,91)=1;
  g1(44,8)=(-(T486*(-params(123))));
  g1(44,21)=(-(T486*(-params(136))));
  g1(44,26)=(-(T486*(-params(137))));
  g1(44,38)=1;
  g1(44,44)=(-((1+params(4))*T486));
  g1(44,52)=(-(T486*(-params(150))));
  g1(44,53)=(-(T486*(-params(151))));
  g1(44,54)=(-(T486*(-params(124))));
  g1(44,55)=(-T486);
  g1(44,57)=T486;
  g1(45,8)=(-(T511*(-params(125))));
  g1(45,20)=(-(T511*(-params(142))));
  g1(45,22)=(-(T511*(-params(143))));
  g1(45,39)=1;
  g1(45,45)=(-((1+params(4))*T511));
  g1(45,52)=(-(T511*(-params(152))));
  g1(45,53)=(-(T511*(-params(153))));
  g1(45,54)=(-(T511*(-params(126))));
  g1(45,56)=(-T511);
  g1(45,59)=T511;
  g1(46,20)=(-1);
  g1(46,38)=1;
  g1(46,40)=1;
  g1(47,21)=(-1);
  g1(47,39)=1;
  g1(47,41)=1;
  g1(48,15)=1;
  g1(48,20)=1;
  g1(48,30)=1;
  g1(48,34)=(-1);
  g1(49,14)=(-1);
  g1(49,16)=1;
  g1(49,21)=1;
  g1(49,31)=1;
  g1(49,35)=(-1);
  g1(50,42)=1;
  g1(51,32)=params(35);
  g1(51,34)=(-params(91));
  g1(51,43)=params(91)-params(35);
  g1(52,3)=1;
  g1(52,17)=(-1);
  g1(52,87)=1;
  g1(53,4)=1;
  g1(53,18)=(-1);
  g1(53,88)=1;
  g1(54,81)=1;
  g1(54,87)=(-1);
  g1(54,88)=1;
  g1(55,15)=1;
  g1(55,20)=1;
  g1(55,25)=(-1);
  g1(55,74)=1;
  g1(56,3)=(-((-params(95))-params(101)*(1+params(93))-params(102)*(1+params(94))));
  g1(56,8)=params(12);
  g1(56,17)=(-(params(101)*(1+params(93))));
  g1(56,18)=(-(params(102)*(1+params(94))));
  g1(56,22)=params(86);
  g1(56,24)=params(101)-params(101)*(1+params(93));
  g1(56,25)=params(102)-params(102)*(1+params(94));
  g1(56,36)=params(84);
  g1(56,75)=(-params(160));
  g1(56,76)=(-(params(158)*params(159)));
  g1(56,77)=(-(params(158)*params(159)));
  g1(57,11)=params(160)*(params(18)-1);
  g1(57,15)=(-params(160));
  g1(57,20)=(-params(160));
  g1(57,75)=params(160);
  g1(58,22)=params(3);
  g1(58,57)=T156;
  g1(58,76)=params(4);
  g1(58,77)=(-1);
  g1(59,20)=1;
  g1(59,44)=(-1);
  g1(59,76)=(-1);
  g1(60,9)=1;
  g1(60,17)=(-1);
  g1(60,78)=1;
  g1(61,18)=(-1);
  g1(61,61)=1;
  g1(61,79)=1;
  g1(62,78)=(-1);
  g1(62,79)=1;
  g1(62,80)=1;
  g1(63,82)=1;
  g1(64,83)=1;
  g1(65,84)=1;
  g1(66,85)=1;
  g1(67,86)=1;
  g1(68,89)=1;
  g1(69,90)=1;
  g1(70,3)=(-((1-params(5))*params(6)));
  g1(70,17)=1-params(5);
  g1(70,40)=(-((1-params(5))*params(7)));
  g1(70,46)=(-1);
  g1(71,4)=(-((1-params(5))*params(14)));
  g1(71,18)=1-params(5);
  g1(71,35)=(-((1-params(5))*params(109)));
  g1(71,41)=(-((1-params(5))*params(15)));
  g1(71,47)=(-1);
  g1(72,15)=(-T670)-T832;
  g1(72,20)=(-T670)-((1-params(105))*params(9)+T832);
  g1(72,34)=(-T681);
  g1(72,36)=T670-T670*params(105);
  g1(72,50)=(-1);
  g1(72,52)=(-(params(88)*(1-params(105))*params(107)));
  g1(73,14)=T698-(T698*params(106)+T710);
  g1(73,16)=(-T698)-((-(T698*params(106)))-T710);
  g1(73,21)=(-T698)-((1-params(106))*params(17)+(-(T698*params(106)))-T710);
  g1(73,35)=(-T710);
  g1(73,37)=T698-T698*params(106);
  g1(73,51)=(-1);
  g1(73,53)=(-(params(89)*(1-params(106))*params(108)));
  g1(74,44)=1-params(42);
  g1(74,45)=(-params(44));
  g1(75,44)=(-params(44));
  g1(75,45)=1-params(43);
  g1(76,46)=1-params(45);
  g1(76,47)=(-params(47));
  g1(77,46)=(-params(47));
  g1(77,47)=1-params(46);
  g1(78,48)=1;
  g1(79,49)=1;
  g1(80,50)=1-params(51);
  g1(80,51)=(-params(53));
  g1(81,50)=(-params(53));
  g1(81,51)=1-params(52);
  g1(82,52)=1;
  g1(83,53)=1;
  g1(84,55)=1;
  g1(85,56)=1;
  g1(86,73)=1;
  g1(87,67)=1;
  g1(88,68)=1;
  g1(89,69)=1;
  g1(90,70)=1;
  g1(91,71)=1;
  g1(92,72)=1;
  if ~isreal(g1)
    g1 = real(g1)+2*imag(g1);
  end
if nargout >= 3,
  %
  % Hessian matrix
  %

  g2 = sparse([],[],[],92,8464);
if nargout >= 4,
  %
  % Third order derivatives
  %

  g3 = sparse([],[],[],92,778688);
end
end
end
end
